import{S as Qd,i as Zd,s as ef,e as i,k as c,w as P,t,M as tf,c as a,d as n,m,a as r,x as D,h as o,b as _,G as e,g as E,y as x,q as k,o as I,B as C,v as of,L as fl}from"../../chunks/vendor-hf-doc-builder.js";import{T as Te}from"../../chunks/Tip-hf-doc-builder.js";import{D as V}from"../../chunks/Docstring-hf-doc-builder.js";import{C as pl}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Bn}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as dl}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function nf(A){let l;return{c(){l=t("One should not use the Diffusion Pipeline class for training or fine-tuning a diffusion model. Individual \n	components of diffusion pipelines are usually trained individually, so we suggest to directly work \n	with `UNetModel` and `UNetConditionModel`.")},l(v){l=o(v,"One should not use the Diffusion Pipeline class for training or fine-tuning a diffusion model. Individual \n	components of diffusion pipelines are usually trained individually, so we suggest to directly work \n	with `UNetModel` and `UNetConditionModel`.")},m(v,u){E(v,l,u)},d(v){v&&n(l)}}}function af(A){let l,v,u,h,$;return h=new pl({props:{code:`from diffusers import (
    StableDiffusionPipeline,
    StableDiffusionImg2ImgPipeline,
    StableDiffusionInpaintPipeline,
)

text2img = StableDiffusionPipeline.from_pretrained("runwayml/stable-diffusion-v1-5")
img2img = StableDiffusionImg2ImgPipeline(**text2img.components)
inpaint = StableDiffusionInpaintPipeline(**text2img.components)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> (
<span class="hljs-meta">... </span>    StableDiffusionPipeline,
<span class="hljs-meta">... </span>    StableDiffusionImg2ImgPipeline,
<span class="hljs-meta">... </span>    StableDiffusionInpaintPipeline,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>text2img = StableDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>img2img = StableDiffusionImg2ImgPipeline(**text2img.components)
<span class="hljs-meta">&gt;&gt;&gt; </span>inpaint = StableDiffusionInpaintPipeline(**text2img.components)`}}),{c(){l=i("p"),v=t("Examples:"),u=c(),P(h.$$.fragment)},l(d){l=a(d,"P",{});var g=r(l);v=o(g,"Examples:"),g.forEach(n),u=m(d),D(h.$$.fragment,d)},m(d,g){E(d,l,g),e(l,v),E(d,u,g),x(h,d,g),$=!0},p:fl,i(d){$||(k(h.$$.fragment,d),$=!0)},o(d){I(h.$$.fragment,d),$=!1},d(d){d&&n(l),d&&n(u),C(h,d)}}}function rf(A){let l,v;return{c(){l=i("p"),v=t("This is an experimental feature and is likely to change in the future.")},l(u){l=a(u,"P",{});var h=r(l);v=o(h,"This is an experimental feature and is likely to change in the future."),h.forEach(n)},m(u,h){E(u,l,h),e(l,v)},d(u){u&&n(l)}}}function sf(A){let l,v,u,h,$;return{c(){l=i("p"),v=t("It is required that the model repo has a file, called "),u=i("code"),h=t("pipeline.py"),$=t(` that defines the custom
pipeline.`)},l(d){l=a(d,"P",{});var g=r(l);v=o(g,"It is required that the model repo has a file, called "),u=a(g,"CODE",{});var O=r(u);h=o(O,"pipeline.py"),O.forEach(n),$=o(g,` that defines the custom
pipeline.`),g.forEach(n)},m(d,g){E(d,l,g),e(l,v),e(l,u),e(u,h),e(l,$)},d(d){d&&n(l)}}}function lf(A){let l,v,u,h,$;return{c(){l=i("p"),v=t("Community pipelines are always loaded from the current "),u=i("code"),h=t("main"),$=t(" branch of GitHub.")},l(d){l=a(d,"P",{});var g=r(l);v=o(g,"Community pipelines are always loaded from the current "),u=a(g,"CODE",{});var O=r(u);h=o(O,"main"),O.forEach(n),$=o(g," branch of GitHub."),g.forEach(n)},m(d,g){E(d,l,g),e(l,v),e(l,u),e(u,h),e(l,$)},d(d){d&&n(l)}}}function df(A){let l,v,u,h,$;return{c(){l=i("p"),v=t("It is required that the directory has a file, called "),u=i("code"),h=t("pipeline.py"),$=t(` that defines the custom
pipeline.`)},l(d){l=a(d,"P",{});var g=r(l);v=o(g,"It is required that the directory has a file, called "),u=a(g,"CODE",{});var O=r(u);h=o(O,"pipeline.py"),O.forEach(n),$=o(g,` that defines the custom
pipeline.`),g.forEach(n)},m(d,g){E(d,l,g),e(l,v),e(l,u),e(u,h),e(l,$)},d(d){d&&n(l)}}}function ff(A){let l,v,u,h,$,d,g;return{c(){l=i("p"),v=t("It is required to be logged in ("),u=i("code"),h=t("huggingface-cli login"),$=t(") when you want to use private or "),d=i("a"),g=t(`gated
models`),this.h()},l(O){l=a(O,"P",{});var q=r(l);v=o(q,"It is required to be logged in ("),u=a(q,"CODE",{});var U=r(u);h=o(U,"huggingface-cli login"),U.forEach(n),$=o(q,") when you want to use private or "),d=a(q,"A",{href:!0,rel:!0});var M=r(d);g=o(M,`gated
models`),M.forEach(n),q.forEach(n),this.h()},h(){_(d,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),_(d,"rel","nofollow")},m(O,q){E(O,l,q),e(l,v),e(l,u),e(u,h),e(l,$),e(l,d),e(d,g)},d(O){O&&n(l)}}}function pf(A){let l,v,u,h,$;return h=new pl({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){l=i("p"),v=t("Examples:"),u=c(),P(h.$$.fragment)},l(d){l=a(d,"P",{});var g=r(l);v=o(g,"Examples:"),g.forEach(n),u=m(d),D(h.$$.fragment,d)},m(d,g){E(d,l,g),e(l,v),E(d,u,g),x(h,d,g),$=!0},p:fl,i(d){$||(k(h.$$.fragment,d),$=!0)},o(d){I(h.$$.fragment,d),$=!1},d(d){d&&n(l),d&&n(u),C(h,d)}}}function cf(A){let l,v,u,h,$,d,g,O,q,U,M,Q,Y;return{c(){l=i("p"),v=t("It is required to be logged in ("),u=i("code"),h=t("huggingface-cli login"),$=t(") when you want to use private or "),d=i("a"),g=t(`gated
models`),O=t(", "),q=i("em"),U=t("e.g."),M=c(),Q=i("code"),Y=t('"runwayml/stable-diffusion-v1-5"'),this.h()},l(Z){l=a(Z,"P",{});var N=r(l);v=o(N,"It is required to be logged in ("),u=a(N,"CODE",{});var B=r(u);h=o(B,"huggingface-cli login"),B.forEach(n),$=o(N,") when you want to use private or "),d=a(N,"A",{href:!0,rel:!0});var mt=r(d);g=o(mt,`gated
models`),mt.forEach(n),O=o(N,", "),q=a(N,"EM",{});var ut=r(q);U=o(ut,"e.g."),ut.forEach(n),M=m(N),Q=a(N,"CODE",{});var je=r(Q);Y=o(je,'"runwayml/stable-diffusion-v1-5"'),je.forEach(n),N.forEach(n),this.h()},h(){_(d,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),_(d,"rel","nofollow")},m(Z,N){E(Z,l,N),e(l,v),e(l,u),e(u,h),e(l,$),e(l,d),e(d,g),e(l,O),e(l,q),e(q,U),e(l,M),e(l,Q),e(Q,Y)},d(Z){Z&&n(l)}}}function mf(A){let l,v,u,h,$;return{c(){l=i("p"),v=t("Activate the special "),u=i("a"),h=t("\u201Coffline-mode\u201D"),$=t(` to use
this method in a firewalled environment.`),this.h()},l(d){l=a(d,"P",{});var g=r(l);v=o(g,"Activate the special "),u=a(g,"A",{href:!0,rel:!0});var O=r(u);h=o(O,"\u201Coffline-mode\u201D"),O.forEach(n),$=o(g,` to use
this method in a firewalled environment.`),g.forEach(n),this.h()},h(){_(u,"href","https://huggingface.co/diffusers/installation.html#offline-mode"),_(u,"rel","nofollow")},m(d,g){E(d,l,g),e(l,v),e(l,u),e(u,h),e(l,$)},d(d){d&&n(l)}}}function uf(A){let l,v,u,h,$;return h=new pl({props:{code:`from diffusers import DiffusionPipeline

# Download pipeline from huggingface.co and cache.
pipeline = DiffusionPipeline.from_pretrained("CompVis/ldm-text2im-large-256")

# Download pipeline that requires an authorization token
# For more information on access tokens, please refer to this section
# of the documentation](https://huggingface.co/docs/hub/security-tokens)
pipeline = DiffusionPipeline.from_pretrained("runwayml/stable-diffusion-v1-5")

# Use a different scheduler
from diffusers import LMSDiscreteScheduler

scheduler = LMSDiscreteScheduler.from_config(pipeline.scheduler.config)
pipeline.scheduler = scheduler`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline from huggingface.co and cache.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;CompVis/ldm-text2im-large-256&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline that requires an authorization token</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># For more information on access tokens, please refer to this section</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># of the documentation](https://huggingface.co/docs/hub/security-tokens)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Use a different scheduler</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> LMSDiscreteScheduler

<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = LMSDiscreteScheduler.from_config(pipeline.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.scheduler = scheduler`}}),{c(){l=i("p"),v=t("Examples:"),u=c(),P(h.$$.fragment)},l(d){l=a(d,"P",{});var g=r(l);v=o(g,"Examples:"),g.forEach(n),u=m(d),D(h.$$.fragment,d)},m(d,g){E(d,l,g),e(l,v),E(d,u,g),x(h,d,g),$=!0},p:fl,i(d){$||(k(h.$$.fragment,d),$=!0)},o(d){I(h.$$.fragment,d),$=!1},d(d){d&&n(l),d&&n(u),C(h,d)}}}function hf(A){let l,v,u,h,$,d,g,O,q,U,M,Q,Y,Z,N,B,mt,ut,je,de,_n,L,Rn,ht,Jn,Kn,It,Qn,Zn,gt,ei,ti,Ct,oi,ni,Ot,ii,ai,At,ri,si,vn,fe,li,_t,di,fi,bn,ee,pe,Tt,Le,pi,jt,ci,$n,y,Se,mi,Lt,ui,hi,vt,bt,gi,_i,vi,qe,St,bi,$i,qt,yi,wi,Mt,Ei,Pi,Me,ce,Wt,Di,xi,Ft,ki,Ii,Ci,me,Nt,Oi,Ai,zt,Ti,ji,Li,ue,We,Si,Vt,qi,Mi,$t,Fe,Wi,yt,Ne,Fi,R,ze,Ni,Ve,zi,Ht,Vi,Hi,Xi,he,Ui,ge,He,Gi,Xe,Yi,Xt,Bi,Ri,Ji,_e,Ue,Ki,Ut,Qi,Zi,T,Ge,ea,Gt,ta,oa,te,na,Yt,ia,aa,Bt,ra,sa,la,ve,da,Rt,fa,pa,oe,Ye,G,ca,Jt,ma,ua,Be,ha,ga,Kt,_a,va,ba,be,$a,Re,z,ya,Qt,wa,Ea,Je,Pa,Da,Zt,xa,ka,eo,Ia,Ca,to,Oa,Aa,Ta,$e,ja,Ke,ne,La,oo,Sa,qa,no,Ma,Wa,Fa,ye,Na,wt,za,Qe,Va,Ha,f,Xa,io,Ua,Ga,ao,Ya,Ba,ro,Ra,Ja,so,Ka,Qa,lo,Za,er,fo,tr,or,po,nr,ir,co,ar,rr,mo,sr,lr,uo,dr,fr,ho,pr,cr,go,mr,ur,_o,hr,gr,vo,_r,vr,bo,br,$r,$o,yr,wr,yo,Er,Pr,wo,Dr,xr,Eo,kr,Ir,Po,Cr,Or,Do,Ar,Tr,xo,jr,Lr,ko,Sr,qr,Io,Mr,Wr,Co,Fr,Nr,Oo,zr,Vr,Ao,Hr,Xr,To,Ur,Gr,jo,Yr,Br,Lo,Rr,Jr,So,Kr,Qr,qo,Zr,es,Mo,ts,os,Wo,ns,is,Fo,as,rs,No,ss,ls,zo,ds,fs,Vo,ps,cs,ms,we,us,J,Ze,hs,Ho,gs,_s,Xo,vs,bs,H,et,$s,Uo,ys,ws,Go,Es,Ps,Yo,Ds,xs,Ee,ks,j,tt,Is,Bo,Cs,Os,ot,As,Ro,Ts,js,Ls,nt,Ss,Jo,qs,Ms,Ws,it,Fs,Ko,Ns,zs,Vs,Pe,Hs,De,Xs,xe,Us,ke,at,Gs,Qo,Ys,Bs,Ie,rt,Rs,st,Js,Zo,Ks,Qs,yn,ie,Ce,en,lt,Zs,tn,el,wn,ae,dt,tl,on,ol,En,re,Oe,nn,ft,nl,an,il,Pn,se,pt,al,rn,rl,Dn;return d=new Bn({}),de=new Te({props:{$$slots:{default:[nf]},$$scope:{ctx:A}}}),Le=new Bn({}),Se=new V({props:{name:"class diffusers.DiffusionPipeline",anchor:"diffusers.DiffusionPipeline",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L401"}}),We=new V({props:{name:"__call__",anchor:"diffusers.DiffusionPipeline.__call__",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}]}}),Fe=new V({props:{name:"device",anchor:"diffusers.DiffusionPipeline.device",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L592",returnDescription:`
<p>The torch device on which the pipeline is located.</p>
`,returnType:`
<p><code>torch.device</code></p>
`}}),Ne=new V({props:{name:"to",anchor:"diffusers.DiffusionPipeline.to",parameters:[{name:"torch_device",val:": typing.Union[str, torch.device, NoneType] = None"},{name:"torch_dtype",val:": typing.Optional[torch.dtype] = None"},{name:"silence_dtype_warnings",val:": bool = False"}],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L533"}}),ze=new V({props:{name:"components",anchor:"diffusers.DiffusionPipeline.components",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L1239",returnDescription:`
<p>A dictionary containing all the modules needed to initialize the pipeline.</p>
`}}),he=new dl({props:{anchor:"diffusers.DiffusionPipeline.components.example",$$slots:{default:[af]},$$scope:{ctx:A}}}),He=new V({props:{name:"disable_attention_slicing",anchor:"diffusers.DiffusionPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L1383"}}),Ue=new V({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.DiffusionPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L1342"}}),Ge=new V({props:{name:"download",anchor:"diffusers.DiffusionPipeline.download",parameters:[{name:"pretrained_model_name",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.download.pretrained_model_name",description:`<strong>pretrained_model_name</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Should be a string, the <em>repo id</em> of a pretrained pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a> Valid repo ids have to be located under a user or organization name, like
<code>CompVis/ldm-text2im-large-256</code>.`,name:"pretrained_model_name"}],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L993"}}),ve=new Te({props:{warning:!0,$$slots:{default:[rf]},$$scope:{ctx:A}}}),be=new Te({props:{$$slots:{default:[sf]},$$scope:{ctx:A}}}),$e=new Te({props:{$$slots:{default:[lf]},$$scope:{ctx:A}}}),ye=new Te({props:{$$slots:{default:[df]},$$scope:{ctx:A}}}),we=new Te({props:{$$slots:{default:[ff]},$$scope:{ctx:A}}}),Ze=new V({props:{name:"enable_attention_slicing",anchor:"diffusers.DiffusionPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L1367"}}),et=new V({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.DiffusionPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L1310"}}),Ee=new dl({props:{anchor:"diffusers.DiffusionPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[pf]},$$scope:{ctx:A}}}),tt=new V({props:{name:"from_pretrained",anchor:"diffusers.DiffusionPipeline.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike, NoneType]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>repo id</em> of a pretrained pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a> Valid repo ids have to be located under a user or organization name, like
<code>CompVis/ldm-text2im-large-256</code>.</li>
<li>A path to a <em>directory</em> containing pipeline weights saved using
<a href="/docs/diffusers/pr_2882/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.save_pretrained">save_pretrained()</a>, e.g., <code>./my_pipeline_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.torch_dtype",description:`<strong>torch_dtype</strong> (<code>str</code> or <code>torch.dtype</code>, <em>optional</em>) &#x2014;
Override the default <code>torch.dtype</code> and load the model under this dtype. If <code>&quot;auto&quot;</code> is passed the dtype
will be automatically derived from the model&#x2019;s weights.`,name:"torch_dtype"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.custom_pipeline",description:`<strong>custom_pipeline</strong> (<code>str</code>, <em>optional</em>) &#x2014;</p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p>This is an experimental feature and is likely to change in the future.</p>

					</div>
<p>Can be either:</p>
<ul>
<li>
<p>A string, the <em>repo id</em> of a custom pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a>. Valid repo ids have to be located under a user or organization name,
like <code>hf-internal-testing/diffusers-dummy-pipeline</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>It is required that the model repo has a file, called <code>pipeline.py</code> that defines the custom
pipeline.</p>

					</div>
</li>
<li>
<p>A string, the <em>file name</em> of a community pipeline hosted on GitHub under
<a href="https://github.com/huggingface/diffusers/tree/main/examples/community" rel="nofollow">https://github.com/huggingface/diffusers/tree/main/examples/community</a>. Valid file names have to
match exactly the file name without <code>.py</code> located under the above link, <em>e.g.</em>
<code>clip_guided_stable_diffusion</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Community pipelines are always loaded from the current <code>main</code> branch of GitHub.</p>

					</div>
</li>
<li>
<p>A path to a <em>directory</em> containing a custom pipeline, e.g., <code>./my_pipeline_directory/</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>It is required that the directory has a file, called <code>pipeline.py</code> that defines the custom
pipeline.</p>

					</div>
</li>
</ul>
<p>For more information on how to load and create custom pipelines, please have a look at <a href="https://huggingface.co/docs/diffusers/using-diffusers/custom_pipeline_overview" rel="nofollow">Loading and
Adding Custom
Pipelines</a>`,name:"custom_pipeline"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.output_loading_info(bool,",description:`<strong>output_loading_info(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.`,name:"output_loading_info(bool,"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.custom_revision",description:`<strong>custom_revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code> when loading from the Hub and to local version of <code>diffusers</code> when loading from GitHub) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id similar to
<code>revision</code> when loading a custom pipeline from the Hub. It can be a diffusers version when loading a
custom pipeline from GitHub.`,name:"custom_revision"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information. specify the folder name here.`,name:"mirror"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.device_map",description:`<strong>device_map</strong> (<code>str</code> or <code>Dict[str, Union[int, str, torch.device]]</code>, <em>optional</em>) &#x2014;
A map that specifies where each submodule should go. It doesn&#x2019;t need to be refined to each
parameter/buffer name, once a given module name is inside, every submodule of it will be sent to the
same device.</p>
<p>To have Accelerate compute the most optimized <code>device_map</code> automatically, set <code>device_map=&quot;auto&quot;</code>. For
more information about each option see <a href="https://hf.co/docs/accelerate/main/en/usage_guides/big_modeling#designing-a-device-map" rel="nofollow">designing a device
map</a>.`,name:"device_map"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.low_cpu_mem_usage",description:`<strong>low_cpu_mem_usage</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code> if torch version &gt;= 1.9.0 else <code>False</code>) &#x2014;
Speed up model loading by not initializing the weights and only loading the pre-trained weights. This
also tries to not use more than 1x model size in CPU memory (including peak memory) while loading the
model. This is only supported when torch version &gt;= 1.9.0. If you are using an older version of torch,
setting this argument to <code>True</code> will raise an error.`,name:"low_cpu_mem_usage"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.use_safetensors",description:`<strong>use_safetensors</strong> (<code>bool</code>, <em>optional</em> ) &#x2014;
If set to <code>True</code>, the pipeline will be loaded from <code>safetensors</code> weights. If set to <code>None</code> (the
default). The pipeline will load using <code>safetensors</code> if the safetensors weights are available <em>and</em> if
<code>safetensors</code> is installed. If the to <code>False</code> the pipeline will <em>not</em> use <code>safetensors</code>.`,name:"use_safetensors"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.kwargs",description:`<strong>kwargs</strong> (remaining dictionary of keyword arguments, <em>optional</em>) &#x2014;
Can be used to overwrite load - and saveable variables - <em>i.e.</em> the pipeline components - of the
specific pipeline class. The overwritten components are then directly passed to the pipelines
<code>__init__</code> method. See example below for more information.`,name:"kwargs"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified load weights from <code>variant</code> filename, <em>e.g.</em> pytorch_model.<variant>.bin. <code>variant</code> is
ignored when using <code>from_flax</code>.</variant>`,name:"variant"}],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L605"}}),Pe=new Te({props:{$$slots:{default:[cf]},$$scope:{ctx:A}}}),De=new Te({props:{$$slots:{default:[mf]},$$scope:{ctx:A}}}),xe=new dl({props:{anchor:"diffusers.DiffusionPipeline.from_pretrained.example",$$slots:{default:[uf]},$$scope:{ctx:A}}}),at=new V({props:{name:"numpy_to_pil",anchor:"diffusers.DiffusionPipeline.numpy_to_pil",parameters:[{name:"images",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L1276"}}),rt=new V({props:{name:"save_pretrained",anchor:"diffusers.DiffusionPipeline.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"safe_serialization",val:": bool = False"},{name:"variant",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.DiffusionPipeline.save_pretrained.safe_serialization",description:`<strong>safe_serialization</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to save the model using <code>safetensors</code> or the traditional PyTorch way (that uses <code>pickle</code>).`,name:"safe_serialization"},{anchor:"diffusers.DiffusionPipeline.save_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified, weights are saved in the format pytorch_model.<variant>.bin.</variant>`,name:"variant"}],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L458"}}),lt=new Bn({}),dt=new V({props:{name:"class diffusers.ImagePipelineOutput",anchor:"diffusers.ImagePipelineOutput",parameters:[{name:"images",val:": typing.Union[typing.List[PIL.Image.Image], numpy.ndarray]"}],parametersDescription:[{anchor:"diffusers.ImagePipelineOutput.images",description:`<strong>images</strong> (<code>List[PIL.Image.Image]</code> or <code>np.ndarray</code>) &#x2014;
List of denoised PIL images of length <code>batch_size</code> or numpy array of shape <code>(batch_size, height, width, num_channels)</code>. PIL images or numpy array present the denoised images of the diffusion pipeline.`,name:"images"}],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L110"}}),ft=new Bn({}),pt=new V({props:{name:"class diffusers.AudioPipelineOutput",anchor:"diffusers.AudioPipelineOutput",parameters:[{name:"audios",val:": ndarray"}],parametersDescription:[{anchor:"diffusers.AudioPipelineOutput.audios",description:`<strong>audios</strong> (<code>np.ndarray</code>) &#x2014;
List of denoised samples of shape <code>(batch_size, num_channels, sample_rate)</code>. Numpy array present the
denoised audio samples of the diffusion pipeline.`,name:"audios"}],source:"https://github.com/huggingface/diffusers/blob/vr_2882/src/diffusers/pipelines/pipeline_utils.py#L124"}}),{c(){l=i("meta"),v=c(),u=i("h1"),h=i("a"),$=i("span"),P(d.$$.fragment),g=c(),O=i("span"),q=t("Pipelines"),U=c(),M=i("p"),Q=t("The "),Y=i("a"),Z=t("DiffusionPipeline"),N=t(" is the easiest way to load any pretrained diffusion pipeline from the "),B=i("a"),mt=t("Hub"),ut=t(" and to use it in inference."),je=c(),P(de.$$.fragment),_n=c(),L=i("p"),Rn=t("Any diffusion pipeline that is loaded with "),ht=i("a"),Jn=t("from_pretrained()"),Kn=t(` will automatically
detect the pipeline type, `),It=i("em"),Qn=t("e.g."),Zn=c(),gt=i("a"),ei=t("StableDiffusionPipeline"),ti=t(` and consequently load each component of the
pipeline and pass them into the `),Ct=i("code"),oi=t("__init__"),ni=t(" function of the pipeline, "),Ot=i("em"),ii=t("e.g."),ai=c(),At=i("code"),ri=t("__init__()"),si=t("."),vn=c(),fe=i("p"),li=t("Any pipeline object can be saved locally with "),_t=i("a"),di=t("save_pretrained()"),fi=t("."),bn=c(),ee=i("h2"),pe=i("a"),Tt=i("span"),P(Le.$$.fragment),pi=c(),jt=i("span"),ci=t("DiffusionPipeline"),$n=c(),y=i("div"),P(Se.$$.fragment),mi=c(),Lt=i("p"),ui=t("Base class for all models."),hi=c(),vt=i("p"),bt=i("a"),gi=t("DiffusionPipeline"),_i=t(` takes care of storing all components (models, schedulers, processors) for diffusion pipelines
and handles methods for loading, downloading and saving models as well as a few methods common to all pipelines to:`),vi=c(),qe=i("ul"),St=i("li"),bi=t("move all PyTorch modules to the device of your choice"),$i=c(),qt=i("li"),yi=t("enabling/disabling the progress bar for the denoising iteration"),wi=c(),Mt=i("p"),Ei=t("Class attributes:"),Pi=c(),Me=i("ul"),ce=i("li"),Wt=i("strong"),Di=t("config_name"),xi=t(" ("),Ft=i("code"),ki=t("str"),Ii=t(`) \u2014 name of the config file that will store the class and module names of all
components of the diffusion pipeline.`),Ci=c(),me=i("li"),Nt=i("strong"),Oi=t("_optional_components"),Ai=t(" (List"),zt=i("code"),Ti=t("str"),ji=t(`) \u2014 list of all components that are optional so they don\u2019t have to be
passed for the pipeline to function (should be overridden by subclasses).`),Li=c(),ue=i("div"),P(We.$$.fragment),Si=c(),Vt=i("p"),qi=t("Call self as a function."),Mi=c(),$t=i("div"),P(Fe.$$.fragment),Wi=c(),yt=i("div"),P(Ne.$$.fragment),Fi=c(),R=i("div"),P(ze.$$.fragment),Ni=c(),Ve=i("p"),zi=t("The "),Ht=i("code"),Vi=t("self.components"),Hi=t(` property can be useful to run different pipelines with the same weights and
configurations to not have to re-allocate memory.`),Xi=c(),P(he.$$.fragment),Ui=c(),ge=i("div"),P(He.$$.fragment),Gi=c(),Xe=i("p"),Yi=t("Disable sliced attention computation. If "),Xt=i("code"),Bi=t("enable_attention_slicing"),Ri=t(` was previously invoked, this method will go
back to computing attention in one step.`),Ji=c(),_e=i("div"),P(Ue.$$.fragment),Ki=c(),Ut=i("p"),Qi=t("Disable memory efficient attention as implemented in xformers."),Zi=c(),T=i("div"),P(Ge.$$.fragment),ea=c(),Gt=i("p"),ta=t("Download and cache a PyTorch diffusion pipeline from pre-trained pipeline weights."),oa=c(),te=i("p"),na=t("custom_pipeline ("),Yt=i("code"),ia=t("str"),aa=t(", "),Bt=i("em"),ra=t("optional"),sa=t("):"),la=c(),P(ve.$$.fragment),da=c(),Rt=i("p"),fa=t("Can be either:"),pa=c(),oe=i("ul"),Ye=i("li"),G=i("p"),ca=t("A string, the "),Jt=i("em"),ma=t("repo id"),ua=t(` of a custom pipeline hosted inside a model repo on
`),Be=i("a"),ha=t("https://huggingface.co/"),ga=t(`. Valid repo ids have to be located under a user or organization name,
like `),Kt=i("code"),_a=t("hf-internal-testing/diffusers-dummy-pipeline"),va=t("."),ba=c(),P(be.$$.fragment),$a=c(),Re=i("li"),z=i("p"),ya=t("A string, the "),Qt=i("em"),wa=t("file name"),Ea=t(` of a community pipeline hosted on GitHub under
`),Je=i("a"),Pa=t("https://github.com/huggingface/diffusers/tree/main/examples/community"),Da=t(`. Valid file names have to
match exactly the file name without `),Zt=i("code"),xa=t(".py"),ka=t(" located under the above link, "),eo=i("em"),Ia=t("e.g."),Ca=c(),to=i("code"),Oa=t("clip_guided_stable_diffusion"),Aa=t("."),Ta=c(),P($e.$$.fragment),ja=c(),Ke=i("li"),ne=i("p"),La=t("A path to a "),oo=i("em"),Sa=t("directory"),qa=t(" containing a custom pipeline, e.g., "),no=i("code"),Ma=t("./my_pipeline_directory/"),Wa=t("."),Fa=c(),P(ye.$$.fragment),Na=c(),wt=i("p"),za=t("For more information on how to load and create custom pipelines, please have a look at "),Qe=i("a"),Va=t(`Loading and
Adding Custom
Pipelines`),Ha=c(),f=i("p"),Xa=t("force_download ("),io=i("code"),Ua=t("bool"),Ga=t(", "),ao=i("em"),Ya=t("optional"),Ba=t(", defaults to "),ro=i("code"),Ra=t("False"),Ja=t(`):
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.
resume_download (`),so=i("code"),Ka=t("bool"),Qa=t(", "),lo=i("em"),Za=t("optional"),er=t(", defaults to "),fo=i("code"),tr=t("False"),or=t(`):
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.
proxies (`),po=i("code"),nr=t("Dict[str, str]"),ir=t(", "),co=i("em"),ar=t("optional"),rr=t(`):
A dictionary of proxy servers to use by protocol or endpoint, e.g., `),mo=i("code"),sr=t("{'http': 'foo.bar:3128', 'http://hostname': 'foo.bar:4012'}"),lr=t(`. The proxies are used on each request.
output_loading_info(`),uo=i("code"),dr=t("bool"),fr=t(", "),ho=i("em"),pr=t("optional"),cr=t(", defaults to "),go=i("code"),mr=t("False"),ur=t(`):
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.
local_files_only(`),_o=i("code"),hr=t("bool"),gr=t(", "),vo=i("em"),_r=t("optional"),vr=t(", defaults to "),bo=i("code"),br=t("False"),$r=t(`):
Whether or not to only look at local files (i.e., do not try to download the model).
use_auth_token (`),$o=i("code"),yr=t("str"),wr=t(" or "),yo=i("em"),Er=t("bool"),Pr=t(", "),wo=i("em"),Dr=t("optional"),xr=t(`):
The token to use as HTTP bearer authorization for remote files. If `),Eo=i("code"),kr=t("True"),Ir=t(`, will use the token generated
when running `),Po=i("code"),Cr=t("huggingface-cli login"),Or=t(" (stored in "),Do=i("code"),Ar=t("~/.huggingface"),Tr=t(`).
revision (`),xo=i("code"),jr=t("str"),Lr=t(", "),ko=i("em"),Sr=t("optional"),qr=t(", defaults to "),Io=i("code"),Mr=t('"main"'),Wr=t(`):
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so `),Co=i("code"),Fr=t("revision"),Nr=t(` can be any
identifier allowed by git.
custom_revision (`),Oo=i("code"),zr=t("str"),Vr=t(", "),Ao=i("em"),Hr=t("optional"),Xr=t(", defaults to "),To=i("code"),Ur=t('"main"'),Gr=t(` when loading from the Hub and to local version of
`),jo=i("code"),Yr=t("diffusers"),Br=t(` when loading from GitHub):
The specific model version to use. It can be a branch name, a tag name, or a commit id similar to
`),Lo=i("code"),Rr=t("revision"),Jr=t(` when loading a custom pipeline from the Hub. It can be a diffusers version when loading a
custom pipeline from GitHub.
mirror (`),So=i("code"),Kr=t("str"),Qr=t(", "),qo=i("em"),Zr=t("optional"),es=t(`):
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information. specify the folder name here.
variant (`),Mo=i("code"),ts=t("str"),os=t(", "),Wo=i("em"),ns=t("optional"),is=t(`):
If specified load weights from `),Fo=i("code"),as=t("variant"),rs=t(" filename, "),No=i("em"),ss=t("e.g."),ls=t(" pytorch_model.<variant>.bin. "),zo=i("code"),ds=t("variant"),fs=t(` is
ignored when using `),Vo=i("code"),ps=t("from_flax"),cs=t("."),ms=c(),P(we.$$.fragment),us=c(),J=i("div"),P(Ze.$$.fragment),hs=c(),Ho=i("p"),gs=t("Enable sliced attention computation."),_s=c(),Xo=i("p"),vs=t(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),bs=c(),H=i("div"),P(et.$$.fragment),$s=c(),Uo=i("p"),ys=t("Enable memory efficient attention as implemented in xformers."),ws=c(),Go=i("p"),Es=t(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Ps=c(),Yo=i("p"),Ds=t(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),xs=c(),P(Ee.$$.fragment),ks=c(),j=i("div"),P(tt.$$.fragment),Is=c(),Bo=i("p"),Cs=t("Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights."),Os=c(),ot=i("p"),As=t("The pipeline is set in evaluation mode by default using "),Ro=i("code"),Ts=t("model.eval()"),js=t(" (Dropout modules are deactivated)."),Ls=c(),nt=i("p"),Ss=t("The warning "),Jo=i("em"),qs=t("Weights from XXX not initialized from pretrained model"),Ms=t(` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),Ws=c(),it=i("p"),Fs=t("The warning "),Ko=i("em"),Ns=t("Weights from XXX not used in YYY"),zs=t(` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),Vs=c(),P(Pe.$$.fragment),Hs=c(),P(De.$$.fragment),Xs=c(),P(xe.$$.fragment),Us=c(),ke=i("div"),P(at.$$.fragment),Gs=c(),Qo=i("p"),Ys=t("Convert a numpy image or a batch of images to a PIL image."),Bs=c(),Ie=i("div"),P(rt.$$.fragment),Rs=c(),st=i("p"),Js=t(`Save all variables of the pipeline that can be saved and loaded as well as the pipelines configuration file to
a directory. A pipeline variable can be saved and loaded if its class implements both a save and loading
method. The pipeline can easily be re-loaded using the `),Zo=i("code"),Ks=t("[from_pretrained()](/docs/diffusers/pr_2882/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.from_pretrained)"),Qs=t(" class method."),yn=c(),ie=i("h2"),Ce=i("a"),en=i("span"),P(lt.$$.fragment),Zs=c(),tn=i("span"),el=t("ImagePipelineOutput"),wn=t(`

By default diffusion pipelines return an object of class
`),ae=i("div"),P(dt.$$.fragment),tl=c(),on=i("p"),ol=t("Output class for image pipelines."),En=c(),re=i("h2"),Oe=i("a"),nn=i("span"),P(ft.$$.fragment),nl=c(),an=i("span"),il=t("AudioPipelineOutput"),Pn=t(`

By default diffusion pipelines return an object of class
`),se=i("div"),P(pt.$$.fragment),al=c(),rn=i("p"),rl=t("Output class for audio pipelines."),this.h()},l(s){const b=tf('[data-svelte="svelte-1phssyn"]',document.head);l=a(b,"META",{name:!0,content:!0}),b.forEach(n),v=m(s),u=a(s,"H1",{class:!0});var ct=r(u);h=a(ct,"A",{id:!0,class:!0,href:!0});var sn=r(h);$=a(sn,"SPAN",{});var ln=r($);D(d.$$.fragment,ln),ln.forEach(n),sn.forEach(n),g=m(ct),O=a(ct,"SPAN",{});var dn=r(O);q=o(dn,"Pipelines"),dn.forEach(n),ct.forEach(n),U=m(s),M=a(s,"P",{});var le=r(M);Q=o(le,"The "),Y=a(le,"A",{href:!0});var fn=r(Y);Z=o(fn,"DiffusionPipeline"),fn.forEach(n),N=o(le," is the easiest way to load any pretrained diffusion pipeline from the "),B=a(le,"A",{href:!0,rel:!0});var pn=r(B);mt=o(pn,"Hub"),pn.forEach(n),ut=o(le," and to use it in inference."),le.forEach(n),je=m(s),D(de.$$.fragment,s),_n=m(s),L=a(s,"P",{});var W=r(L);Rn=o(W,"Any diffusion pipeline that is loaded with "),ht=a(W,"A",{href:!0});var cn=r(ht);Jn=o(cn,"from_pretrained()"),cn.forEach(n),Kn=o(W,` will automatically
detect the pipeline type, `),It=a(W,"EM",{});var mn=r(It);Qn=o(mn,"e.g."),mn.forEach(n),Zn=m(W),gt=a(W,"A",{href:!0});var un=r(gt);ei=o(un,"StableDiffusionPipeline"),un.forEach(n),ti=o(W,` and consequently load each component of the
pipeline and pass them into the `),Ct=a(W,"CODE",{});var cl=r(Ct);oi=o(cl,"__init__"),cl.forEach(n),ni=o(W," function of the pipeline, "),Ot=a(W,"EM",{});var ml=r(Ot);ii=o(ml,"e.g."),ml.forEach(n),ai=m(W),At=a(W,"CODE",{});var ul=r(At);ri=o(ul,"__init__()"),ul.forEach(n),si=o(W,"."),W.forEach(n),vn=m(s),fe=a(s,"P",{});var xn=r(fe);li=o(xn,"Any pipeline object can be saved locally with "),_t=a(xn,"A",{href:!0});var hl=r(_t);di=o(hl,"save_pretrained()"),hl.forEach(n),fi=o(xn,"."),xn.forEach(n),bn=m(s),ee=a(s,"H2",{class:!0});var kn=r(ee);pe=a(kn,"A",{id:!0,class:!0,href:!0});var gl=r(pe);Tt=a(gl,"SPAN",{});var _l=r(Tt);D(Le.$$.fragment,_l),_l.forEach(n),gl.forEach(n),pi=m(kn),jt=a(kn,"SPAN",{});var vl=r(jt);ci=o(vl,"DiffusionPipeline"),vl.forEach(n),kn.forEach(n),$n=m(s),y=a(s,"DIV",{class:!0});var w=r(y);D(Se.$$.fragment,w),mi=m(w),Lt=a(w,"P",{});var bl=r(Lt);ui=o(bl,"Base class for all models."),bl.forEach(n),hi=m(w),vt=a(w,"P",{});var sl=r(vt);bt=a(sl,"A",{href:!0});var $l=r(bt);gi=o($l,"DiffusionPipeline"),$l.forEach(n),_i=o(sl,` takes care of storing all components (models, schedulers, processors) for diffusion pipelines
and handles methods for loading, downloading and saving models as well as a few methods common to all pipelines to:`),sl.forEach(n),vi=m(w),qe=a(w,"UL",{});var In=r(qe);St=a(In,"LI",{});var yl=r(St);bi=o(yl,"move all PyTorch modules to the device of your choice"),yl.forEach(n),$i=m(In),qt=a(In,"LI",{});var wl=r(qt);yi=o(wl,"enabling/disabling the progress bar for the denoising iteration"),wl.forEach(n),In.forEach(n),wi=m(w),Mt=a(w,"P",{});var El=r(Mt);Ei=o(El,"Class attributes:"),El.forEach(n),Pi=m(w),Me=a(w,"UL",{});var Cn=r(Me);ce=a(Cn,"LI",{});var hn=r(ce);Wt=a(hn,"STRONG",{});var Pl=r(Wt);Di=o(Pl,"config_name"),Pl.forEach(n),xi=o(hn," ("),Ft=a(hn,"CODE",{});var Dl=r(Ft);ki=o(Dl,"str"),Dl.forEach(n),Ii=o(hn,`) \u2014 name of the config file that will store the class and module names of all
components of the diffusion pipeline.`),hn.forEach(n),Ci=m(Cn),me=a(Cn,"LI",{});var gn=r(me);Nt=a(gn,"STRONG",{});var xl=r(Nt);Oi=o(xl,"_optional_components"),xl.forEach(n),Ai=o(gn," (List"),zt=a(gn,"CODE",{});var kl=r(zt);Ti=o(kl,"str"),kl.forEach(n),ji=o(gn,`) \u2014 list of all components that are optional so they don\u2019t have to be
passed for the pipeline to function (should be overridden by subclasses).`),gn.forEach(n),Cn.forEach(n),Li=m(w),ue=a(w,"DIV",{class:!0});var On=r(ue);D(We.$$.fragment,On),Si=m(On),Vt=a(On,"P",{});var Il=r(Vt);qi=o(Il,"Call self as a function."),Il.forEach(n),On.forEach(n),Mi=m(w),$t=a(w,"DIV",{class:!0});var Cl=r($t);D(Fe.$$.fragment,Cl),Cl.forEach(n),Wi=m(w),yt=a(w,"DIV",{class:!0});var Ol=r(yt);D(Ne.$$.fragment,Ol),Ol.forEach(n),Fi=m(w),R=a(w,"DIV",{class:!0});var Et=r(R);D(ze.$$.fragment,Et),Ni=m(Et),Ve=a(Et,"P",{});var An=r(Ve);zi=o(An,"The "),Ht=a(An,"CODE",{});var Al=r(Ht);Vi=o(Al,"self.components"),Al.forEach(n),Hi=o(An,` property can be useful to run different pipelines with the same weights and
configurations to not have to re-allocate memory.`),An.forEach(n),Xi=m(Et),D(he.$$.fragment,Et),Et.forEach(n),Ui=m(w),ge=a(w,"DIV",{class:!0});var Tn=r(ge);D(He.$$.fragment,Tn),Gi=m(Tn),Xe=a(Tn,"P",{});var jn=r(Xe);Yi=o(jn,"Disable sliced attention computation. If "),Xt=a(jn,"CODE",{});var Tl=r(Xt);Bi=o(Tl,"enable_attention_slicing"),Tl.forEach(n),Ri=o(jn,` was previously invoked, this method will go
back to computing attention in one step.`),jn.forEach(n),Tn.forEach(n),Ji=m(w),_e=a(w,"DIV",{class:!0});var Ln=r(_e);D(Ue.$$.fragment,Ln),Ki=m(Ln),Ut=a(Ln,"P",{});var jl=r(Ut);Qi=o(jl,"Disable memory efficient attention as implemented in xformers."),jl.forEach(n),Ln.forEach(n),Zi=m(w),T=a(w,"DIV",{class:!0});var S=r(T);D(Ge.$$.fragment,S),ea=m(S),Gt=a(S,"P",{});var Ll=r(Gt);ta=o(Ll,"Download and cache a PyTorch diffusion pipeline from pre-trained pipeline weights."),Ll.forEach(n),oa=m(S),te=a(S,"P",{});var Pt=r(te);na=o(Pt,"custom_pipeline ("),Yt=a(Pt,"CODE",{});var Sl=r(Yt);ia=o(Sl,"str"),Sl.forEach(n),aa=o(Pt,", "),Bt=a(Pt,"EM",{});var ql=r(Bt);ra=o(ql,"optional"),ql.forEach(n),sa=o(Pt,"):"),Pt.forEach(n),la=m(S),D(ve.$$.fragment,S),da=m(S),Rt=a(S,"P",{});var Ml=r(Rt);fa=o(Ml,"Can be either:"),Ml.forEach(n),pa=m(S),oe=a(S,"UL",{});var Dt=r(oe);Ye=a(Dt,"LI",{});var Sn=r(Ye);G=a(Sn,"P",{});var Ae=r(G);ca=o(Ae,"A string, the "),Jt=a(Ae,"EM",{});var Wl=r(Jt);ma=o(Wl,"repo id"),Wl.forEach(n),ua=o(Ae,` of a custom pipeline hosted inside a model repo on
`),Be=a(Ae,"A",{href:!0,rel:!0});var Fl=r(Be);ha=o(Fl,"https://huggingface.co/"),Fl.forEach(n),ga=o(Ae,`. Valid repo ids have to be located under a user or organization name,
like `),Kt=a(Ae,"CODE",{});var Nl=r(Kt);_a=o(Nl,"hf-internal-testing/diffusers-dummy-pipeline"),Nl.forEach(n),va=o(Ae,"."),Ae.forEach(n),ba=m(Sn),D(be.$$.fragment,Sn),Sn.forEach(n),$a=m(Dt),Re=a(Dt,"LI",{});var qn=r(Re);z=a(qn,"P",{});var X=r(z);ya=o(X,"A string, the "),Qt=a(X,"EM",{});var zl=r(Qt);wa=o(zl,"file name"),zl.forEach(n),Ea=o(X,` of a community pipeline hosted on GitHub under
`),Je=a(X,"A",{href:!0,rel:!0});var Vl=r(Je);Pa=o(Vl,"https://github.com/huggingface/diffusers/tree/main/examples/community"),Vl.forEach(n),Da=o(X,`. Valid file names have to
match exactly the file name without `),Zt=a(X,"CODE",{});var Hl=r(Zt);xa=o(Hl,".py"),Hl.forEach(n),ka=o(X," located under the above link, "),eo=a(X,"EM",{});var Xl=r(eo);Ia=o(Xl,"e.g."),Xl.forEach(n),Ca=m(X),to=a(X,"CODE",{});var Ul=r(to);Oa=o(Ul,"clip_guided_stable_diffusion"),Ul.forEach(n),Aa=o(X,"."),X.forEach(n),Ta=m(qn),D($e.$$.fragment,qn),qn.forEach(n),ja=m(Dt),Ke=a(Dt,"LI",{});var Mn=r(Ke);ne=a(Mn,"P",{});var xt=r(ne);La=o(xt,"A path to a "),oo=a(xt,"EM",{});var Gl=r(oo);Sa=o(Gl,"directory"),Gl.forEach(n),qa=o(xt," containing a custom pipeline, e.g., "),no=a(xt,"CODE",{});var Yl=r(no);Ma=o(Yl,"./my_pipeline_directory/"),Yl.forEach(n),Wa=o(xt,"."),xt.forEach(n),Fa=m(Mn),D(ye.$$.fragment,Mn),Mn.forEach(n),Dt.forEach(n),Na=m(S),wt=a(S,"P",{});var ll=r(wt);za=o(ll,"For more information on how to load and create custom pipelines, please have a look at "),Qe=a(ll,"A",{href:!0,rel:!0});var Bl=r(Qe);Va=o(Bl,`Loading and
Adding Custom
Pipelines`),Bl.forEach(n),ll.forEach(n),Ha=m(S),f=a(S,"P",{});var p=r(f);Xa=o(p,"force_download ("),io=a(p,"CODE",{});var Rl=r(io);Ua=o(Rl,"bool"),Rl.forEach(n),Ga=o(p,", "),ao=a(p,"EM",{});var Jl=r(ao);Ya=o(Jl,"optional"),Jl.forEach(n),Ba=o(p,", defaults to "),ro=a(p,"CODE",{});var Kl=r(ro);Ra=o(Kl,"False"),Kl.forEach(n),Ja=o(p,`):
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.
resume_download (`),so=a(p,"CODE",{});var Ql=r(so);Ka=o(Ql,"bool"),Ql.forEach(n),Qa=o(p,", "),lo=a(p,"EM",{});var Zl=r(lo);Za=o(Zl,"optional"),Zl.forEach(n),er=o(p,", defaults to "),fo=a(p,"CODE",{});var ed=r(fo);tr=o(ed,"False"),ed.forEach(n),or=o(p,`):
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.
proxies (`),po=a(p,"CODE",{});var td=r(po);nr=o(td,"Dict[str, str]"),td.forEach(n),ir=o(p,", "),co=a(p,"EM",{});var od=r(co);ar=o(od,"optional"),od.forEach(n),rr=o(p,`):
A dictionary of proxy servers to use by protocol or endpoint, e.g., `),mo=a(p,"CODE",{});var nd=r(mo);sr=o(nd,"{'http': 'foo.bar:3128', 'http://hostname': 'foo.bar:4012'}"),nd.forEach(n),lr=o(p,`. The proxies are used on each request.
output_loading_info(`),uo=a(p,"CODE",{});var id=r(uo);dr=o(id,"bool"),id.forEach(n),fr=o(p,", "),ho=a(p,"EM",{});var ad=r(ho);pr=o(ad,"optional"),ad.forEach(n),cr=o(p,", defaults to "),go=a(p,"CODE",{});var rd=r(go);mr=o(rd,"False"),rd.forEach(n),ur=o(p,`):
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.
local_files_only(`),_o=a(p,"CODE",{});var sd=r(_o);hr=o(sd,"bool"),sd.forEach(n),gr=o(p,", "),vo=a(p,"EM",{});var ld=r(vo);_r=o(ld,"optional"),ld.forEach(n),vr=o(p,", defaults to "),bo=a(p,"CODE",{});var dd=r(bo);br=o(dd,"False"),dd.forEach(n),$r=o(p,`):
Whether or not to only look at local files (i.e., do not try to download the model).
use_auth_token (`),$o=a(p,"CODE",{});var fd=r($o);yr=o(fd,"str"),fd.forEach(n),wr=o(p," or "),yo=a(p,"EM",{});var pd=r(yo);Er=o(pd,"bool"),pd.forEach(n),Pr=o(p,", "),wo=a(p,"EM",{});var cd=r(wo);Dr=o(cd,"optional"),cd.forEach(n),xr=o(p,`):
The token to use as HTTP bearer authorization for remote files. If `),Eo=a(p,"CODE",{});var md=r(Eo);kr=o(md,"True"),md.forEach(n),Ir=o(p,`, will use the token generated
when running `),Po=a(p,"CODE",{});var ud=r(Po);Cr=o(ud,"huggingface-cli login"),ud.forEach(n),Or=o(p," (stored in "),Do=a(p,"CODE",{});var hd=r(Do);Ar=o(hd,"~/.huggingface"),hd.forEach(n),Tr=o(p,`).
revision (`),xo=a(p,"CODE",{});var gd=r(xo);jr=o(gd,"str"),gd.forEach(n),Lr=o(p,", "),ko=a(p,"EM",{});var _d=r(ko);Sr=o(_d,"optional"),_d.forEach(n),qr=o(p,", defaults to "),Io=a(p,"CODE",{});var vd=r(Io);Mr=o(vd,'"main"'),vd.forEach(n),Wr=o(p,`):
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so `),Co=a(p,"CODE",{});var bd=r(Co);Fr=o(bd,"revision"),bd.forEach(n),Nr=o(p,` can be any
identifier allowed by git.
custom_revision (`),Oo=a(p,"CODE",{});var $d=r(Oo);zr=o($d,"str"),$d.forEach(n),Vr=o(p,", "),Ao=a(p,"EM",{});var yd=r(Ao);Hr=o(yd,"optional"),yd.forEach(n),Xr=o(p,", defaults to "),To=a(p,"CODE",{});var wd=r(To);Ur=o(wd,'"main"'),wd.forEach(n),Gr=o(p,` when loading from the Hub and to local version of
`),jo=a(p,"CODE",{});var Ed=r(jo);Yr=o(Ed,"diffusers"),Ed.forEach(n),Br=o(p,` when loading from GitHub):
The specific model version to use. It can be a branch name, a tag name, or a commit id similar to
`),Lo=a(p,"CODE",{});var Pd=r(Lo);Rr=o(Pd,"revision"),Pd.forEach(n),Jr=o(p,` when loading a custom pipeline from the Hub. It can be a diffusers version when loading a
custom pipeline from GitHub.
mirror (`),So=a(p,"CODE",{});var Dd=r(So);Kr=o(Dd,"str"),Dd.forEach(n),Qr=o(p,", "),qo=a(p,"EM",{});var xd=r(qo);Zr=o(xd,"optional"),xd.forEach(n),es=o(p,`):
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information. specify the folder name here.
variant (`),Mo=a(p,"CODE",{});var kd=r(Mo);ts=o(kd,"str"),kd.forEach(n),os=o(p,", "),Wo=a(p,"EM",{});var Id=r(Wo);ns=o(Id,"optional"),Id.forEach(n),is=o(p,`):
If specified load weights from `),Fo=a(p,"CODE",{});var Cd=r(Fo);as=o(Cd,"variant"),Cd.forEach(n),rs=o(p," filename, "),No=a(p,"EM",{});var Od=r(No);ss=o(Od,"e.g."),Od.forEach(n),ls=o(p," pytorch_model.<variant>.bin. "),zo=a(p,"CODE",{});var Ad=r(zo);ds=o(Ad,"variant"),Ad.forEach(n),fs=o(p,` is
ignored when using `),Vo=a(p,"CODE",{});var Td=r(Vo);ps=o(Td,"from_flax"),Td.forEach(n),cs=o(p,"."),p.forEach(n),ms=m(S),D(we.$$.fragment,S),S.forEach(n),us=m(w),J=a(w,"DIV",{class:!0});var kt=r(J);D(Ze.$$.fragment,kt),hs=m(kt),Ho=a(kt,"P",{});var jd=r(Ho);gs=o(jd,"Enable sliced attention computation."),jd.forEach(n),_s=m(kt),Xo=a(kt,"P",{});var Ld=r(Xo);vs=o(Ld,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Ld.forEach(n),kt.forEach(n),bs=m(w),H=a(w,"DIV",{class:!0});var K=r(H);D(et.$$.fragment,K),$s=m(K),Uo=a(K,"P",{});var Sd=r(Uo);ys=o(Sd,"Enable memory efficient attention as implemented in xformers."),Sd.forEach(n),ws=m(K),Go=a(K,"P",{});var qd=r(Go);Es=o(qd,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),qd.forEach(n),Ps=m(K),Yo=a(K,"P",{});var Md=r(Yo);Ds=o(Md,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Md.forEach(n),xs=m(K),D(Ee.$$.fragment,K),K.forEach(n),ks=m(w),j=a(w,"DIV",{class:!0});var F=r(j);D(tt.$$.fragment,F),Is=m(F),Bo=a(F,"P",{});var Wd=r(Bo);Cs=o(Wd,"Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights."),Wd.forEach(n),Os=m(F),ot=a(F,"P",{});var Wn=r(ot);As=o(Wn,"The pipeline is set in evaluation mode by default using "),Ro=a(Wn,"CODE",{});var Fd=r(Ro);Ts=o(Fd,"model.eval()"),Fd.forEach(n),js=o(Wn," (Dropout modules are deactivated)."),Wn.forEach(n),Ls=m(F),nt=a(F,"P",{});var Fn=r(nt);Ss=o(Fn,"The warning "),Jo=a(Fn,"EM",{});var Nd=r(Jo);qs=o(Nd,"Weights from XXX not initialized from pretrained model"),Nd.forEach(n),Ms=o(Fn,` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),Fn.forEach(n),Ws=m(F),it=a(F,"P",{});var Nn=r(it);Fs=o(Nn,"The warning "),Ko=a(Nn,"EM",{});var zd=r(Ko);Ns=o(zd,"Weights from XXX not used in YYY"),zd.forEach(n),zs=o(Nn,` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),Nn.forEach(n),Vs=m(F),D(Pe.$$.fragment,F),Hs=m(F),D(De.$$.fragment,F),Xs=m(F),D(xe.$$.fragment,F),F.forEach(n),Us=m(w),ke=a(w,"DIV",{class:!0});var zn=r(ke);D(at.$$.fragment,zn),Gs=m(zn),Qo=a(zn,"P",{});var Vd=r(Qo);Ys=o(Vd,"Convert a numpy image or a batch of images to a PIL image."),Vd.forEach(n),zn.forEach(n),Bs=m(w),Ie=a(w,"DIV",{class:!0});var Vn=r(Ie);D(rt.$$.fragment,Vn),Rs=m(Vn),st=a(Vn,"P",{});var Hn=r(st);Js=o(Hn,`Save all variables of the pipeline that can be saved and loaded as well as the pipelines configuration file to
a directory. A pipeline variable can be saved and loaded if its class implements both a save and loading
method. The pipeline can easily be re-loaded using the `),Zo=a(Hn,"CODE",{});var Hd=r(Zo);Ks=o(Hd,"[from_pretrained()](/docs/diffusers/pr_2882/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.from_pretrained)"),Hd.forEach(n),Qs=o(Hn," class method."),Hn.forEach(n),Vn.forEach(n),w.forEach(n),yn=m(s),ie=a(s,"H2",{class:!0});var Xn=r(ie);Ce=a(Xn,"A",{id:!0,class:!0,href:!0});var Xd=r(Ce);en=a(Xd,"SPAN",{});var Ud=r(en);D(lt.$$.fragment,Ud),Ud.forEach(n),Xd.forEach(n),Zs=m(Xn),tn=a(Xn,"SPAN",{});var Gd=r(tn);el=o(Gd,"ImagePipelineOutput"),Gd.forEach(n),Xn.forEach(n),wn=o(s,`

By default diffusion pipelines return an object of class
`),ae=a(s,"DIV",{class:!0});var Un=r(ae);D(dt.$$.fragment,Un),tl=m(Un),on=a(Un,"P",{});var Yd=r(on);ol=o(Yd,"Output class for image pipelines."),Yd.forEach(n),Un.forEach(n),En=m(s),re=a(s,"H2",{class:!0});var Gn=r(re);Oe=a(Gn,"A",{id:!0,class:!0,href:!0});var Bd=r(Oe);nn=a(Bd,"SPAN",{});var Rd=r(nn);D(ft.$$.fragment,Rd),Rd.forEach(n),Bd.forEach(n),nl=m(Gn),an=a(Gn,"SPAN",{});var Jd=r(an);il=o(Jd,"AudioPipelineOutput"),Jd.forEach(n),Gn.forEach(n),Pn=o(s,`

By default diffusion pipelines return an object of class
`),se=a(s,"DIV",{class:!0});var Yn=r(se);D(pt.$$.fragment,Yn),al=m(Yn),rn=a(Yn,"P",{});var Kd=r(rn);rl=o(Kd,"Output class for audio pipelines."),Kd.forEach(n),Yn.forEach(n),this.h()},h(){_(l,"name","hf:doc:metadata"),_(l,"content",JSON.stringify(gf)),_(h,"id","pipelines"),_(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),_(h,"href","#pipelines"),_(u,"class","relative group"),_(Y,"href","/docs/diffusers/pr_2882/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),_(B,"href","https://huggingface.co/models?library=diffusers"),_(B,"rel","nofollow"),_(ht,"href","/docs/diffusers/pr_2882/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.from_pretrained"),_(gt,"href","/docs/diffusers/pr_2882/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline"),_(_t,"href","/docs/diffusers/pr_2882/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.save_pretrained"),_(pe,"id","diffusers.DiffusionPipeline"),_(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),_(pe,"href","#diffusers.DiffusionPipeline"),_(ee,"class","relative group"),_(bt,"href","/docs/diffusers/pr_2882/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),_(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_($t,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(yt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(Be,"href","https://huggingface.co/"),_(Be,"rel","nofollow"),_(Je,"href","https://github.com/huggingface/diffusers/tree/main/examples/community"),_(Je,"rel","nofollow"),_(Qe,"href","https://huggingface.co/docs/diffusers/using-diffusers/custom_pipeline_overview"),_(Qe,"rel","nofollow"),_(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(Ce,"id","diffusers.ImagePipelineOutput"),_(Ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),_(Ce,"href","#diffusers.ImagePipelineOutput"),_(ie,"class","relative group"),_(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),_(Oe,"id","diffusers.AudioPipelineOutput"),_(Oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),_(Oe,"href","#diffusers.AudioPipelineOutput"),_(re,"class","relative group"),_(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(s,b){e(document.head,l),E(s,v,b),E(s,u,b),e(u,h),e(h,$),x(d,$,null),e(u,g),e(u,O),e(O,q),E(s,U,b),E(s,M,b),e(M,Q),e(M,Y),e(Y,Z),e(M,N),e(M,B),e(B,mt),e(M,ut),E(s,je,b),x(de,s,b),E(s,_n,b),E(s,L,b),e(L,Rn),e(L,ht),e(ht,Jn),e(L,Kn),e(L,It),e(It,Qn),e(L,Zn),e(L,gt),e(gt,ei),e(L,ti),e(L,Ct),e(Ct,oi),e(L,ni),e(L,Ot),e(Ot,ii),e(L,ai),e(L,At),e(At,ri),e(L,si),E(s,vn,b),E(s,fe,b),e(fe,li),e(fe,_t),e(_t,di),e(fe,fi),E(s,bn,b),E(s,ee,b),e(ee,pe),e(pe,Tt),x(Le,Tt,null),e(ee,pi),e(ee,jt),e(jt,ci),E(s,$n,b),E(s,y,b),x(Se,y,null),e(y,mi),e(y,Lt),e(Lt,ui),e(y,hi),e(y,vt),e(vt,bt),e(bt,gi),e(vt,_i),e(y,vi),e(y,qe),e(qe,St),e(St,bi),e(qe,$i),e(qe,qt),e(qt,yi),e(y,wi),e(y,Mt),e(Mt,Ei),e(y,Pi),e(y,Me),e(Me,ce),e(ce,Wt),e(Wt,Di),e(ce,xi),e(ce,Ft),e(Ft,ki),e(ce,Ii),e(Me,Ci),e(Me,me),e(me,Nt),e(Nt,Oi),e(me,Ai),e(me,zt),e(zt,Ti),e(me,ji),e(y,Li),e(y,ue),x(We,ue,null),e(ue,Si),e(ue,Vt),e(Vt,qi),e(y,Mi),e(y,$t),x(Fe,$t,null),e(y,Wi),e(y,yt),x(Ne,yt,null),e(y,Fi),e(y,R),x(ze,R,null),e(R,Ni),e(R,Ve),e(Ve,zi),e(Ve,Ht),e(Ht,Vi),e(Ve,Hi),e(R,Xi),x(he,R,null),e(y,Ui),e(y,ge),x(He,ge,null),e(ge,Gi),e(ge,Xe),e(Xe,Yi),e(Xe,Xt),e(Xt,Bi),e(Xe,Ri),e(y,Ji),e(y,_e),x(Ue,_e,null),e(_e,Ki),e(_e,Ut),e(Ut,Qi),e(y,Zi),e(y,T),x(Ge,T,null),e(T,ea),e(T,Gt),e(Gt,ta),e(T,oa),e(T,te),e(te,na),e(te,Yt),e(Yt,ia),e(te,aa),e(te,Bt),e(Bt,ra),e(te,sa),e(T,la),x(ve,T,null),e(T,da),e(T,Rt),e(Rt,fa),e(T,pa),e(T,oe),e(oe,Ye),e(Ye,G),e(G,ca),e(G,Jt),e(Jt,ma),e(G,ua),e(G,Be),e(Be,ha),e(G,ga),e(G,Kt),e(Kt,_a),e(G,va),e(Ye,ba),x(be,Ye,null),e(oe,$a),e(oe,Re),e(Re,z),e(z,ya),e(z,Qt),e(Qt,wa),e(z,Ea),e(z,Je),e(Je,Pa),e(z,Da),e(z,Zt),e(Zt,xa),e(z,ka),e(z,eo),e(eo,Ia),e(z,Ca),e(z,to),e(to,Oa),e(z,Aa),e(Re,Ta),x($e,Re,null),e(oe,ja),e(oe,Ke),e(Ke,ne),e(ne,La),e(ne,oo),e(oo,Sa),e(ne,qa),e(ne,no),e(no,Ma),e(ne,Wa),e(Ke,Fa),x(ye,Ke,null),e(T,Na),e(T,wt),e(wt,za),e(wt,Qe),e(Qe,Va),e(T,Ha),e(T,f),e(f,Xa),e(f,io),e(io,Ua),e(f,Ga),e(f,ao),e(ao,Ya),e(f,Ba),e(f,ro),e(ro,Ra),e(f,Ja),e(f,so),e(so,Ka),e(f,Qa),e(f,lo),e(lo,Za),e(f,er),e(f,fo),e(fo,tr),e(f,or),e(f,po),e(po,nr),e(f,ir),e(f,co),e(co,ar),e(f,rr),e(f,mo),e(mo,sr),e(f,lr),e(f,uo),e(uo,dr),e(f,fr),e(f,ho),e(ho,pr),e(f,cr),e(f,go),e(go,mr),e(f,ur),e(f,_o),e(_o,hr),e(f,gr),e(f,vo),e(vo,_r),e(f,vr),e(f,bo),e(bo,br),e(f,$r),e(f,$o),e($o,yr),e(f,wr),e(f,yo),e(yo,Er),e(f,Pr),e(f,wo),e(wo,Dr),e(f,xr),e(f,Eo),e(Eo,kr),e(f,Ir),e(f,Po),e(Po,Cr),e(f,Or),e(f,Do),e(Do,Ar),e(f,Tr),e(f,xo),e(xo,jr),e(f,Lr),e(f,ko),e(ko,Sr),e(f,qr),e(f,Io),e(Io,Mr),e(f,Wr),e(f,Co),e(Co,Fr),e(f,Nr),e(f,Oo),e(Oo,zr),e(f,Vr),e(f,Ao),e(Ao,Hr),e(f,Xr),e(f,To),e(To,Ur),e(f,Gr),e(f,jo),e(jo,Yr),e(f,Br),e(f,Lo),e(Lo,Rr),e(f,Jr),e(f,So),e(So,Kr),e(f,Qr),e(f,qo),e(qo,Zr),e(f,es),e(f,Mo),e(Mo,ts),e(f,os),e(f,Wo),e(Wo,ns),e(f,is),e(f,Fo),e(Fo,as),e(f,rs),e(f,No),e(No,ss),e(f,ls),e(f,zo),e(zo,ds),e(f,fs),e(f,Vo),e(Vo,ps),e(f,cs),e(T,ms),x(we,T,null),e(y,us),e(y,J),x(Ze,J,null),e(J,hs),e(J,Ho),e(Ho,gs),e(J,_s),e(J,Xo),e(Xo,vs),e(y,bs),e(y,H),x(et,H,null),e(H,$s),e(H,Uo),e(Uo,ys),e(H,ws),e(H,Go),e(Go,Es),e(H,Ps),e(H,Yo),e(Yo,Ds),e(H,xs),x(Ee,H,null),e(y,ks),e(y,j),x(tt,j,null),e(j,Is),e(j,Bo),e(Bo,Cs),e(j,Os),e(j,ot),e(ot,As),e(ot,Ro),e(Ro,Ts),e(ot,js),e(j,Ls),e(j,nt),e(nt,Ss),e(nt,Jo),e(Jo,qs),e(nt,Ms),e(j,Ws),e(j,it),e(it,Fs),e(it,Ko),e(Ko,Ns),e(it,zs),e(j,Vs),x(Pe,j,null),e(j,Hs),x(De,j,null),e(j,Xs),x(xe,j,null),e(y,Us),e(y,ke),x(at,ke,null),e(ke,Gs),e(ke,Qo),e(Qo,Ys),e(y,Bs),e(y,Ie),x(rt,Ie,null),e(Ie,Rs),e(Ie,st),e(st,Js),e(st,Zo),e(Zo,Ks),e(st,Qs),E(s,yn,b),E(s,ie,b),e(ie,Ce),e(Ce,en),x(lt,en,null),e(ie,Zs),e(ie,tn),e(tn,el),E(s,wn,b),E(s,ae,b),x(dt,ae,null),e(ae,tl),e(ae,on),e(on,ol),E(s,En,b),E(s,re,b),e(re,Oe),e(Oe,nn),x(ft,nn,null),e(re,nl),e(re,an),e(an,il),E(s,Pn,b),E(s,se,b),x(pt,se,null),e(se,al),e(se,rn),e(rn,rl),Dn=!0},p(s,[b]){const ct={};b&2&&(ct.$$scope={dirty:b,ctx:s}),de.$set(ct);const sn={};b&2&&(sn.$$scope={dirty:b,ctx:s}),he.$set(sn);const ln={};b&2&&(ln.$$scope={dirty:b,ctx:s}),ve.$set(ln);const dn={};b&2&&(dn.$$scope={dirty:b,ctx:s}),be.$set(dn);const le={};b&2&&(le.$$scope={dirty:b,ctx:s}),$e.$set(le);const fn={};b&2&&(fn.$$scope={dirty:b,ctx:s}),ye.$set(fn);const pn={};b&2&&(pn.$$scope={dirty:b,ctx:s}),we.$set(pn);const W={};b&2&&(W.$$scope={dirty:b,ctx:s}),Ee.$set(W);const cn={};b&2&&(cn.$$scope={dirty:b,ctx:s}),Pe.$set(cn);const mn={};b&2&&(mn.$$scope={dirty:b,ctx:s}),De.$set(mn);const un={};b&2&&(un.$$scope={dirty:b,ctx:s}),xe.$set(un)},i(s){Dn||(k(d.$$.fragment,s),k(de.$$.fragment,s),k(Le.$$.fragment,s),k(Se.$$.fragment,s),k(We.$$.fragment,s),k(Fe.$$.fragment,s),k(Ne.$$.fragment,s),k(ze.$$.fragment,s),k(he.$$.fragment,s),k(He.$$.fragment,s),k(Ue.$$.fragment,s),k(Ge.$$.fragment,s),k(ve.$$.fragment,s),k(be.$$.fragment,s),k($e.$$.fragment,s),k(ye.$$.fragment,s),k(we.$$.fragment,s),k(Ze.$$.fragment,s),k(et.$$.fragment,s),k(Ee.$$.fragment,s),k(tt.$$.fragment,s),k(Pe.$$.fragment,s),k(De.$$.fragment,s),k(xe.$$.fragment,s),k(at.$$.fragment,s),k(rt.$$.fragment,s),k(lt.$$.fragment,s),k(dt.$$.fragment,s),k(ft.$$.fragment,s),k(pt.$$.fragment,s),Dn=!0)},o(s){I(d.$$.fragment,s),I(de.$$.fragment,s),I(Le.$$.fragment,s),I(Se.$$.fragment,s),I(We.$$.fragment,s),I(Fe.$$.fragment,s),I(Ne.$$.fragment,s),I(ze.$$.fragment,s),I(he.$$.fragment,s),I(He.$$.fragment,s),I(Ue.$$.fragment,s),I(Ge.$$.fragment,s),I(ve.$$.fragment,s),I(be.$$.fragment,s),I($e.$$.fragment,s),I(ye.$$.fragment,s),I(we.$$.fragment,s),I(Ze.$$.fragment,s),I(et.$$.fragment,s),I(Ee.$$.fragment,s),I(tt.$$.fragment,s),I(Pe.$$.fragment,s),I(De.$$.fragment,s),I(xe.$$.fragment,s),I(at.$$.fragment,s),I(rt.$$.fragment,s),I(lt.$$.fragment,s),I(dt.$$.fragment,s),I(ft.$$.fragment,s),I(pt.$$.fragment,s),Dn=!1},d(s){n(l),s&&n(v),s&&n(u),C(d),s&&n(U),s&&n(M),s&&n(je),C(de,s),s&&n(_n),s&&n(L),s&&n(vn),s&&n(fe),s&&n(bn),s&&n(ee),C(Le),s&&n($n),s&&n(y),C(Se),C(We),C(Fe),C(Ne),C(ze),C(he),C(He),C(Ue),C(Ge),C(ve),C(be),C($e),C(ye),C(we),C(Ze),C(et),C(Ee),C(tt),C(Pe),C(De),C(xe),C(at),C(rt),s&&n(yn),s&&n(ie),C(lt),s&&n(wn),s&&n(ae),C(dt),s&&n(En),s&&n(re),C(ft),s&&n(Pn),s&&n(se),C(pt)}}}const gf={local:"pipelines",sections:[{local:"diffusers.DiffusionPipeline",title:"DiffusionPipeline"},{local:"diffusers.ImagePipelineOutput",title:"ImagePipelineOutput"},{local:"diffusers.AudioPipelineOutput",title:"AudioPipelineOutput"}],title:"Pipelines"};function _f(A){return of(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Pf extends Qd{constructor(l){super();Zd(this,l,_f,hf,ef,{})}}export{Pf as default,gf as metadata};
